"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:max-line-length
/**
 * Workaround for custom errors when compiling typescript targeting 'ES5'.
 * see: https://github.com/Microsoft/TypeScript/wiki/Breaking-Changes#extending-built-ins-like-error-array-and-map-may-no-longer-work
 * @param {NotTypeError} error
 * @param newTarget the value of `new.target`
 * @param {Function} errorType
 * @param errorPrototype
 */
// tslint:enable:max-line-length
function fixError(error, newTarget, errorType, errorPrototype) {
    if (errorPrototype === void 0) { errorPrototype = Error; }
    Object.setPrototypeOf(error, errorType.prototype);
    // when an error constructor is invoked with the `new` operator
    if (newTarget === errorType) {
        if (!error.name)
            error.name = newTarget.name;
        // exclude the constructor call of the error type from the stack trace.
        if (errorPrototype.captureStackTrace) {
            errorPrototype.captureStackTrace(error, errorType);
        }
        else {
            var stack = new errorPrototype(error.message).stack;
            if (stack) {
                error.stack = fixStack(stack, "new " + newTarget.name, error.trace);
            }
        }
    }
}
function fixStack(stack, functionName, trace) {
    if (!stack)
        return stack;
    if (!functionName)
        return stack;
    // exclude lines starts with:  "  at functionName "
    var exclusion = new RegExp("\\s+at\\s" + functionName + "\\s");
    var lines = stack.split('\n');
    var resultLines = lines.filter(function (line) { return !line.match(exclusion); });
    return resultLines.join('\n');
}
var NotTypeError = /** @class */ (function (_super) {
    __extends(NotTypeError, _super);
    function NotTypeError(message, statusCode, debug) {
        var _newTarget = this.constructor;
        if (statusCode === void 0) { statusCode = 400; }
        var _this = this;
        var msgStr = (typeof message === 'string') ? message : message.message;
        _this = _super.call(this, msgStr) || this;
        _this.name = 'TypeError (NotTS)'; // type error, invalid argument, validation error... have been considered. 'Wrong Type' sounds most simple.
        _this.statusCode = statusCode;
        if (typeof message === 'object') {
            _this.trace = message;
            if (typeof debug === 'function')
                debug(message);
        }
        fixError(_this, _newTarget, NotTypeError, TypeError);
        return _this;
    }
    return NotTypeError;
}(TypeError));
exports.default = NotTypeError;
